; -ASM80 DLOAD.ASM
; -LINK DLOAD.OBJ,SYSTEM.LIB TO DLOAD.OUT
; -LOCATE DLOAD.OUT TO DLOAD MAP STACKSIZE(30H)

	EXTRN	ISIS
	
; Equates for system

open	equ	0
close	equ	1
delete	equ	2
read	equ	3
write	equ	4
seek	equ	5
load	equ	6
rename	equ	7
consol	equ	8
exit	equ	9
attrib	equ	10
rescan	equ	11
error	equ	12
whocon	equ	13
spath	equ	14

faRead	equ	1
faWrit	equ	2
faRW	equ	3

skPos	equ	0
skBwd	equ	1
skLoc	equ	2
skFwd	equ	3
skEof	equ	4

; Equates for DLOAD ports

DLdata	equ	0a0h
DLstat	equ	0a1h
DLcntrl	equ	0a1h

DLrdy	equ	1
DLnrdy	equ	0

DLrew	equ	0ffh

cr	equ	13
lf	equ	10

	DSEG

rACT:	dw	0	;actual number of bytes read

rBuf:	ds	64

;  messages

fly:	db	cr,lf,'Dload Version 1.0 for ISIS',cr,lf
flyL	equ	$-fly
dld:	db	cr,lf,'Downloading ...',cr,lf
dldL	equ	$-dld
ndf:	db	cr,lf,'No Dload File Open',cr,lf
ndfL	equ	$-ndf
fe:	db	cr,lf,'File Exists, Ok to Overwrite? (Y or N)<cr> - '
feL	equ	$-fe
fin:	db	cr,lf,'Finished',cr,lf
finL	equ	$-fin
cl:	db	cr,lf,cr,lf
clL	equ	$-cl

wcBuf:	db	'0000h'	;block count
	db	' '
	db	'00h'	;byte count
wcBufL	equ	$-wcBuf

; PBs

pbWcl:	dw	0	;:CO:
	dw	cl	;pointer to crlf
	dw	clL	;count to write
	dw	eStat	;pointer to error status


pbWco:	dw	0	;:CO:
	dw	wcBuf	;pointer to write buffer
wcoCnt:	dw	1	;count to write
	dw	eStat	;pointer to error status

; Write PB
; store aftn for write here after open

fnWrit:
pbWrit:	dw	0	;actual aftn
	dw	wBuf	;pointer to write Buffer
wCount:	dw	1	;Number of bytes to write
	dw	eStat	;pointer to Status

wBuf:	ds	8

; Close PB

fnClos:
pbClos:	dw	0	;Aftn to close
	dw	eStat	;error returned by error

; store error at eStat
; pb for error and exit

eStat:
pbErro:	dw	0	;returned error number
pbExit:	dw	eStat	;error returned by error

	CSEG

Start:	lxi	sp,STACK
	
; write banner

	DSEG

pbWfly:	dw	0	;:CO:
	dw	fly	;pointer to openning banner
	dw	flyL	;count to write
	dw	eStat	;pointer to error status

	CSEG

	mvi	c,write
	lxi	d,pbWfly
	call	ISIS0

; Read from Console PB, used to read cmd line

	DSEG

pbRcon:	dw	1	;:CI:
	dw	rBuf	;pointer to Read Buffer
	dw	32	;Number of bytes to read
	dw	rACT	;return of actual count read
	dw	eStat	;pointer to Status

;read file name from command line

	CSEG

	mvi	c,read
	lxi	d,pbRcon
	call	ISIS0

; test if dload file is open

	mvi	a,DLrew		;rewind file
	out	DLcntrl

	in	DLstat
	cpi	DLrdy
	jz	TestFE

; write no dload file open and exit

	DSEG

pbWndf:	dw	0	;:CO:
	dw	ndf	;pointer to NO Dload File
	dw	ndfL	;count to write
	dw	eStat	;pointer to error status

	CSEG

	mvi	c,write
	lxi	d,pbWndf
	call	ISIS0

	jmp	pExit

; test for file exists 

	DSEG

;Open file PB

pbTest:	dw	fnClos	;pointer to aftn
	dw	rBuf	;pointer to filename
	dw	faRead	;access value
	dw	0	;echo file aftn
	dw	eStat	;pointer to Status

	CSEG
TestFE:

	mvi	c,open
	lxi	d,pbTest
	call	ISIS	; need to see non-fatal errors

	lda	eStat
	cpi	13	;no such file
	jz	DoIt	

	mvi	c,close
	lxi	d,pbClos
	call	ISIS

	DSEG

pbWfe:	dw	0	;:CO:
	dw	fe	;pointer to file exists
	dw	feL	;count to write
	dw	eStat	;pointer to error status

pbRco:	dw	1	;:CI:
	dw	wcBuf	;pointer to Read Buffer
	dw	1	;Number of bytes to read
wciCnt:	dw	wcoCnt	;return of actual count read
	dw	eStat	;pointer to Status

; it exists so ask if ok to overwrite

	CSEG

Exists:
	mvi	c,write
	lxi	d,pbWfe
	call	ISIS0
	
ReadA:	mvi	c,read
	lxi	d,pbRco
	call	ISIS0

	lda	wcBuf
	cpi	'Y'
	jz	DoIt
	cpi	'y'
	jz	DoIt
	cpi	'N'
	jz	Finish
	cpi	'n'
	jz	Finish

	jmp	ReadA
	
;Open file PB

	DSEG

pbOpen:	dw	fnWrit	;pointer to aftn
	dw	rBuf	;pointer to filename
	dw	faWrit	;access value
	dw	0	;echo file aftn
	dw	eStat	;pointer to Status

	CSEG

; Open the file for writing

DoIt:
	mvi	c,open
	lxi	d,pbOpen
	call	ISIS0

; PB write downloading

	DSEG

pbWdld:	dw	0	;:CO:
	dw	dld	;pointer to downloading
	dw	dldL	;count to write
	dw	eStat	;pointer to error status

	CSEG

; PB write downloading

	mvi	c,write
	lxi	d,pbWdld
	call	ISIS0

while:
	in	DLstat
	cpi	DLrdy
	jnz	EOI

	in	DLdata
	sta	wBuf

	in	DLstat
	cpi	DLrdy
	jnz	EOI
	
; write the buffer

	mvi	c,write
	lxi	d,pbWrit
	call	ISIS0

	jmp	while

EOI:

; Close the file

	lhld	fnWrit
	shld	fnClos
	mvi	c,close
	lxi	d,pbClos
	call	ISIS0
	
; write finished and exit

	DSEG

pbWfin:	dw	0	;:CO:
	dw	fin	;pointer to finished
	dw	finL	;count to write
	dw	eStat	;pointer to error status

	CSEG

finish:	mvi	c,write
	lxi	d,pbWfin
	call	ISIS0

	jmp	pExit

; Entry to ISIS  

ISIS0:	call	ISIS
	lda	eStat
	ora	a
	rz
	mvi	c,error
	lxi	d,pbErro
	call	ISIS
pExit:	mvi	c,exit
	lxi	d,pbExit
	call	ISIS
; should not return to here

	end	Start
